import type { ReactNode } from 'react';
import type { CodeMirror, ProvidedCodeMirrorConfig, UseContainerRefHook, UseViewDispatchHook, UseViewEffectHook, UseViewHook } from './types.js';
export interface CodeMirrorProviderProps {
    config?: ProvidedCodeMirrorConfig;
    children: ReactNode;
}
export interface CodeMirrorProvider {
    (props: CodeMirrorProviderProps): JSX.Element;
    displayName?: string;
}
export type UseCodeMirrorContextHook<ContainerElement extends Element = Element> = () => CodeMirror<ContainerElement>;
export interface CodeMirrorWithContext<ContainerElement extends Element = Element> {
    Provider: CodeMirrorProvider;
    useContext: UseCodeMirrorContextHook<ContainerElement>;
    useView: UseViewHook;
    useViewEffect: UseViewEffectHook;
    useViewDispatch: UseViewDispatchHook;
    useContainerRef: UseContainerRefHook<ContainerElement>;
}
export declare function createCodeMirrorWithContext<ContainerElement extends Element>(displayName?: string | false): CodeMirrorWithContext<ContainerElement>;
//# sourceMappingURL=context.d.ts.map